import { RawData, Language, Orama, Result, Results, SearchParams } from '@orama/orama';
export interface Position {
    start: number;
    length: number;
}
export type OramaWithHighlight = Orama & {
    data: {
        positions: Record<string, Record<string, Record<string, Position[]>>>;
    };
};
export type SearchResultWithHighlight = Results & {
    hits: (Result & {
        positions: Position[];
    })[];
};
export type RawDataWithPositions = RawData & {
    positions: Record<string, Record<string, Record<string, Position[]>>>;
};
export declare function afterInsert(orama: Orama | OramaWithHighlight, id: string): Promise<void>;
export declare function searchWithHighlight(orama: OramaWithHighlight, params: SearchParams, language?: Language): Promise<SearchResultWithHighlight>;
export declare function saveWithHighlight(orama: Orama): Promise<RawDataWithPositions>;
export declare function loadWithHighlight(orama: OramaWithHighlight, raw: RawDataWithPositions): Promise<void>;
